import java.lang.*;
public class Mensagem {
   public static final char codErro         = 'a';
   public static final char codLanceCliente = 'b';
   public static final char codNovoLance    = 'c';
   public static final char codFinal        = 'd';
   public static final char codVencedor     = 'e';
   public static final char codInicio       = 'f';
  
   private int passo;
   private char tipo;
   private int quem;
   private int valor;
   
   private Mensagem(char tipo) {
      this.tipo = tipo;
   }
      
   public static Mensagem erro() {
      Mensagem p = new Mensagem(codErro);
      return p;
   }
   public static Mensagem lanceCliente(int valor) {
      Mensagem p = new Mensagem(codLanceCliente);
      p.valor = valor;
      return p;
   }
   public static Mensagem novoLance(int valor) {
      Mensagem p = new Mensagem(codNovoLance);
      p.valor = valor;
      return p;
   }

   public static Mensagem finalizar(int valor) {
      Mensagem p = new Mensagem(codFinal);
      p.valor = valor;
      return p;
   }

   public static Mensagem vencedor() {
      Mensagem p = new Mensagem(codVencedor);
      return p;
   }
   public static Mensagem inicio(int passo, int uLance) {
      Mensagem p = new Mensagem(codInicio);
      p.valor = uLance;
      p.passo = passo;
      return p;
   }

   public static Mensagem stringToMensagem(String a) {
      Mensagem p = new Mensagem('z');
      int i;
      char[] msg = a.toCharArray();
      char tipo = msg[0];
      switch(tipo) {
	 case codErro              : p = Mensagem.erro();
				     break;
				     
	 case codLanceCliente      : p = Mensagem.lanceCliente(Integer.parseInt(new String(msg, 2,msg.length - 2)));
				     break;
				     
	 case codNovoLance         : p = Mensagem.novoLance(Integer.parseInt(new String(msg, 2, msg.length - 2)));
				     break;

	 case codFinal             : p = Mensagem.finalizar(Integer.parseInt(new String(msg, 2, msg.length - 2)));
				     break;

	 case codVencedor          : p = Mensagem.vencedor();
				     break;

	 case codInicio            : for(i=2 ; msg[i+1]!=',' ;i++);;
				     int s1 = Integer.parseInt(new String(msg, 2, i-1));
				     int s2 = Integer.parseInt(new String(msg, i+2, msg.length - i -2));
				     p = Mensagem.inicio( s1, s2);
				     
				     break;
				     
	 default                   : break;
      }
      return p;
   }

   public int getPasso() {
      return this.passo;
   }
   
   public void setPasso(int passo) {
      this.passo = passo;
   }

   public char getTipo() {
      return this.tipo;
   }

   public int getQuem() {
      return this.quem;
   }

   public void setQuem(int quem) { 
      this.quem = quem;
   }

   public int getValor() {
      return this.valor;
   }					     

   public String toString() {
      String a = "";
      a = a + this.tipo + " ";
      switch(this.tipo) {
	 case codErro              : break;

	 case codLanceCliente      : a = a + this.valor;
				     break;

	 case codNovoLance         : a = a + this.valor;
				     break;

	 case codFinal             : a = a + this.valor;
				     break;

	 case codVencedor          : break;

	 case codInicio            : a = a + this.passo + "," + this.valor;
				     break;

	 default                   : break;
      }
      a = a+"\n";
      return a;
   }
}
